//=======================================================================================
// Copyright (C) 2011 Nuvoton Technology(SH) Corp. All rights reserved.
// Author:  Angus Wang. 2013/12/25 
//=======================================================================================
// ĸ, λɲĴ,"GPIO0->PMD"ҵλ
// λ׺ַ:
//  _     :  ʾܱλ, д֮ǰҪ,  PWR_22M_ON_
//  _nbit :  ˶nλ,  I2C_ADRESS_7bit(x)
//  _0    :  궨ֵΪ0
//  _IE   :  жʹ Interrupt Enable 
//  _IF   :  жϱ־λ,Interrupt Flag  
//  _EN   :  ʹ, Enable
//  _DIS  :  ֹ, Disable
//=======================================================================================
#ifndef  __M05xxDE_H__
#define  __M05xxDE_H__

#define  LOCKREG(x)                {GCR->REGWRPROT = 0;}        

typedef enum IRQn{
/******  Cortex-M0 Processor Exceptions Numbers ***************************************************/
  NonMaskableInt_IRQn       = -14,      /*!< 2 Non Maskable Interrupt                             */
  HardFault_IRQn            = -13,      /*!< 3 Cortex-M0 Hard Fault Interrupt                     */
  SVCall_IRQn               = -5,       /*!< 11 Cortex-M0 SV Call Interrupt                       */
  PendSV_IRQn               = -2,       /*!< 14 Cortex-M0 Pend SV Interrupt                       */
  SysTick_IRQn              = -1,       /*!< 15 Cortex-M0 System Tick Interrupt                   */

/******  ARMIKMCU Swift specific Interrupt Numbers ************************************************/
  BOD_IRQn                  = 0,        /*!< Brown-Out Low Voltage Detected Interrupt             */
  WDT_IRQn                  = 1,        /*!< Watch Dog Timer Interrupt                            */
  EINT0_IRQn                = 2,        /*!< EINT0 Interrupt                                      */
  EINT1_IRQn                = 3,        /*!< EINT1 Interrupt                                      */
  GPIO_P0P1_IRQn            = 4,        /*!< GPIO_P0P1 Interrupt                                  */
  GPIO_P2P3P4_IRQn          = 5,        /*!< GPIO_P2P3P4 Interrupt                                */
  PWMA_IRQn                 = 6,        /*!< PWMA Interrupt                                       */
  PWMB_IRQn                 = 7,        /*!< PWMB Interrupt                                       */
  TMR0_IRQn                 = 8,        /*!< TIMER0 Interrupt                                     */
  TMR1_IRQn                 = 9,        /*!< TIMER1 Interrupt                                     */
  TMR2_IRQn                 = 10,       /*!< TIMER2 Interrupt                                     */
  TMR3_IRQn                 = 11,       /*!< TIMER3 Interrupt                                     */
  UART0_IRQn                = 12,       /*!< UART0 Interrupt                                      */
  UART1_IRQn                = 13,       /*!< UART1 Interrupt                                      */
  SPI0_IRQn                 = 14,       /*!< SPI0 Interrupt                                       */
  SPI1_IRQn                 = 15,       /*!< SPI1 Interrupt                                       */
  I2C0_IRQn                 = 18,       /*!< I2C0 Interrupt                                       */
  I2C1_IRQn                 = 19,       /*!< I2C1 Interrupt                                       */
  ACMPA_IRQn                = 25,       /*!< ACMPA Interrupt                                      */
  ACMPB_IRQn                = 26,       /*!< ACMPB Interrupt                                      */
  PWRWU_IRQn                = 28,       /*!< Power Down Wake Up Interrupt                         */
  ADC_IRQn                  = 29        /*!< ADC Interrupt                                        */           
}IRQn_Type ;

#define __NVIC_PRIO_BITS        2       
#include "core_cm0.h"                       

#if defined (__CC_ARM)
  #pragma anon_unions
#endif

//=======================================================================================
//                Device Specific Peripheral registers structures  

#define  FLASH_BASE                ((uint32_t)0x00000000)
#define  SRAM_BASE                 ((uint32_t)0x20000000)
#define  APB1_BASE                 ((uint32_t)0x40000000)
#define  APB2_BASE                 ((uint32_t)0x40100000)
#define  AHB_BASE                  ((uint32_t)0x50000000)

//----------------------------- ACMP Controller -------------------------------------
typedef struct{
    __IO uint32_t  CR0 ;
    __IO uint32_t  CR1 ;
    __IO uint32_t  SR ;
}ACMP_T ;

#define  ACMPA                     ((ACMP_T*)(APB1_BASE + 0xD0000))      
#define  ACMPB                     ((ACMP_T*)(APB2_BASE + 0xD0000))               

//----------------------------- ADC Controller --------------------------------------
typedef struct{
    __I  uint32_t DR[8] ;
    __IO uint32_t CR ;
    __IO uint32_t CHER ;
    __IO uint32_t CMPR0 ;
    __IO uint32_t CMPR1 ;
    __IO uint32_t SR ;
    __I  uint32_t RESERVED0[4] ;    
    __IO uint32_t TDCR ;    
}ADC_T ;

#define  ADC                       ((ADC_T*)(APB1_BASE + 0xE0000)) 

//---------------------------- Clock Controller -------------------------------                                                              
typedef struct{
    __IO uint32_t PWRCON ;
    __IO uint32_t AHBCLK ;
    __IO uint32_t APBCLK ;
    __IO uint32_t CLKSTATUS ;
    __IO uint32_t CLKSEL0 ;
    __IO uint32_t CLKSEL1 ;
    __IO uint32_t CLKDIV ;
    __IO uint32_t CLKSEL2 ;
    __IO uint32_t PLLCON ;
    __IO uint32_t FRQDIV ;
}CLK_T ;
#define  CLK                       ((CLK_T*)(AHB_BASE + 0x00200))

//----------------------- Divider Interface Controller ------------------------
typedef struct{
    __IO  int32_t dividend ;
    __IO  int32_t divsor ;
    __IO  int32_t quotient ;
    __IO  int32_t remainder ;
    __IO uint32_t status ;
}DIV_T ;
                 
#define  DIV                       ((DIV_T*)(AHB_BASE + 0x14000))    

//----------------------- Divider Interface Controller ------------------------
typedef struct{
    __IO uint32_t CON ;
    __IO uint32_t TIME ;
    __IO uint32_t CON2 ;
}EBI_T ;

#define  EBI                       ((EBI_T *)(AHB_BASE + 0x10000))   

//-------------------------- FLASH Memory Controller --------------------------
typedef struct{
    __IO uint32_t CON ;
    __IO uint32_t ADR ;
    __IO uint32_t DAT ;
    __IO uint32_t CMD ;
    __IO uint32_t TRG ;
    __I  uint32_t BASEADR ;
    __IO uint32_t FATCON ;   
    __I  uint32_t Reserved[9];
    __IO uint32_t STA ;

}FMC_T ;

#define  FMC                       ((FMC_T *)(AHB_BASE + 0x0C000))  

//---------------------------- Global Controller ------------------------------
typedef struct{
    __I  uint32_t PDID ;                 
    __IO uint32_t RSTSRC ;
    __IO uint32_t IPRSTC1 ;
    __IO uint32_t IPRSTC2 ;
         uint32_t RESERVED0[2] ;
    __IO uint32_t BODCR ;
    __IO uint32_t TEMPCR ;
         uint32_t RESERVED1 ;
    __IO uint32_t PORCR ;
         uint32_t RESERVED2[2] ;
    __IO uint32_t P0_MFP ;
    __IO uint32_t P1_MFP ;
    __IO uint32_t P2_MFP ;
    __IO uint32_t P3_MFP ;
    __IO uint32_t P4_MFP ;
         uint32_t RESERVED3[47] ;
    __IO uint32_t REGWRPROT ;
}GCR_T ;

#define  GCR                       ((GCR_T *)(AHB_BASE + 0x00000)) 

typedef struct
{
    __I  uint32_t IRQSRC[32];
    __IO uint32_t NMISEL;
    __IO uint32_t MCUIRQ;

}GCR_INT_T ;

#define  GCRINT                    ((GCR_INT_T*)(AHB_BASE + 0x00300)) 

//--------------------- General Purpose Input and Ouptut ----------------------
typedef struct{
    __IO uint32_t  PMD ;                         
    __IO uint32_t  OFFD ;                        
    __IO uint32_t  DOUT ;                        
    __IO uint32_t  DMASK ;                       
    __IO uint32_t  PIN ;                         
    __IO uint32_t  DBEN ;                        
    __IO uint32_t  IMD ;                         
    __IO uint32_t  IEN ;                         
    __IO uint32_t  ISRC ;                        
}GPIO_T ; 

#define  P0                        ((GPIO_T*)(AHB_BASE + 0x4000)) 
#define  P1                        ((GPIO_T*)(AHB_BASE + 0x4040))    
#define  P2                        ((GPIO_T*)(AHB_BASE + 0x4080)) 
#define  P3                        ((GPIO_T*)(AHB_BASE + 0x40C0))    
#define  P4                        ((GPIO_T*)(AHB_BASE + 0x4100))    

#define  GPIODBC                   (*((volatile uint32_t*)(AHB_BASE + 0x4180)))

#define  P00                       (*((volatile uint32_t*)(AHB_BASE + 0x4200)))
#define  P01                       (*((volatile uint32_t*)(AHB_BASE + 0x4204)))
#define  P02                       (*((volatile uint32_t*)(AHB_BASE + 0x4208)))
#define  P03                       (*((volatile uint32_t*)(AHB_BASE + 0x420C)))
#define  P04                       (*((volatile uint32_t*)(AHB_BASE + 0x4210)))
#define  P05                       (*((volatile uint32_t*)(AHB_BASE + 0x4214)))
#define  P06                       (*((volatile uint32_t*)(AHB_BASE + 0x4218)))
#define  P07                       (*((volatile uint32_t*)(AHB_BASE + 0x421C)))

#define  P10                       (*((volatile uint32_t*)(AHB_BASE + 0x4220)))
#define  P11                       (*((volatile uint32_t*)(AHB_BASE + 0x4224)))
#define  P12                       (*((volatile uint32_t*)(AHB_BASE + 0x4228)))
#define  P13                       (*((volatile uint32_t*)(AHB_BASE + 0x422C)))
#define  P14                       (*((volatile uint32_t*)(AHB_BASE + 0x4230)))
#define  P15                       (*((volatile uint32_t*)(AHB_BASE + 0x4234)))
#define  P16                       (*((volatile uint32_t*)(AHB_BASE + 0x4238)))
#define  P17                       (*((volatile uint32_t*)(AHB_BASE + 0x423C)))

#define  P20                       (*((volatile uint32_t*)(AHB_BASE + 0x4240)))
#define  P21                       (*((volatile uint32_t*)(AHB_BASE + 0x4244)))
#define  P22                       (*((volatile uint32_t*)(AHB_BASE + 0x4248)))
#define  P23                       (*((volatile uint32_t*)(AHB_BASE + 0x424C)))
#define  P24                       (*((volatile uint32_t*)(AHB_BASE + 0x4250)))
#define  P25                       (*((volatile uint32_t*)(AHB_BASE + 0x4254)))
#define  P26                       (*((volatile uint32_t*)(AHB_BASE + 0x4258)))
#define  P27                       (*((volatile uint32_t*)(AHB_BASE + 0x425C)))

#define  P30                       (*((volatile uint32_t*)(AHB_BASE + 0x4260)))
#define  P31                       (*((volatile uint32_t*)(AHB_BASE + 0x4264)))
#define  P32                       (*((volatile uint32_t*)(AHB_BASE + 0x4268)))
#define  P33                       (*((volatile uint32_t*)(AHB_BASE + 0x426C)))
#define  P34                       (*((volatile uint32_t*)(AHB_BASE + 0x4270)))
#define  P35                       (*((volatile uint32_t*)(AHB_BASE + 0x4274)))
#define  P36                       (*((volatile uint32_t*)(AHB_BASE + 0x4278)))
#define  P37                       (*((volatile uint32_t*)(AHB_BASE + 0x427C)))

#define  P40                       (*((volatile uint32_t*)(AHB_BASE + 0x4280)))
#define  P41                       (*((volatile uint32_t*)(AHB_BASE + 0x4284)))
#define  P42                       (*((volatile uint32_t*)(AHB_BASE + 0x4288)))
#define  P43                       (*((volatile uint32_t*)(AHB_BASE + 0x428C)))
#define  P44                       (*((volatile uint32_t*)(AHB_BASE + 0x4290)))
#define  P45                       (*((volatile uint32_t*)(AHB_BASE + 0x4294)))
#define  P46                       (*((volatile uint32_t*)(AHB_BASE + 0x4298)))
#define  P47                       (*((volatile uint32_t*)(AHB_BASE + 0x429C)))

//------------------------------ I2C Controller -------------------------------
typedef struct{
    __IO uint32_t CON ;
    __IO uint32_t ADDR0 ;
    __IO uint32_t SDA ;
    __I  uint32_t STATUS ;
    __IO uint32_t SLK ;
    __IO uint32_t TOC ;
    __IO uint32_t ADDR1 ;
    __IO uint32_t ADDR2 ;
    __IO uint32_t ADDR3 ;
    __IO uint32_t ADM0 ;
    __IO uint32_t ADM1 ;
    __IO uint32_t ADM2 ;
    __IO uint32_t ADM3 ;
         uint32_t RESERVED0[2] ;
    __IO uint32_t WKUPCON ;
    __IO uint32_t WKUPSTS ;
}I2C_T ;

#define  I2C0                      ((I2C_T*)(APB1_BASE + 0x20000)) 
#define  I2C1                      ((I2C_T*)(APB2_BASE + 0x20000)) 

//----------------------------- PWM Controller --------------------------------
typedef struct{
    __IO uint32_t PPR ;
    __IO uint32_t CSR ;
    __IO uint32_t PCR ;
    __IO uint32_t CNR0 ;
    __IO uint32_t CMR0 ;
    __I  uint32_t PDR0 ;
    __IO uint32_t CNR1 ;
    __IO uint32_t CMR1 ;
    __I  uint32_t PDR1 ;
    __IO uint32_t CNR2 ;
    __IO uint32_t CMR2 ;
    __I  uint32_t PDR2 ;
    __IO uint32_t CNR3 ;
    __IO uint32_t CMR3 ;
    __I  uint32_t PDR3 ;
    __I  uint32_t RESERVE0 ;
    __IO uint32_t PIER ;
    __IO uint32_t PIIR ;
    __I  uint32_t RESERVE1[2] ;
    __IO uint32_t CCR0 ;
    __IO uint32_t CCR2 ;
    __IO uint32_t CRLR0 ;
    __IO uint32_t CFLR0 ;
    __IO uint32_t CRLR1 ;
    __IO uint32_t CFLR1 ;
    __IO uint32_t CRLR2 ;
    __IO uint32_t CFLR2 ;
    __IO uint32_t CRLR3 ;
    __IO uint32_t CFLR3 ;
    __IO uint32_t CAPENR ;
    __IO uint32_t POE ;
    __IO uint32_t TCON ;
    __IO uint32_t TSTATUS ;
    __I  uint32_t RESERVE2[4] ;
    __IO uint32_t PSCR ;       
}PWM_T ;

#define  PWMA                      ((PWM_T*)(APB1_BASE + 0x40000))
#define  PWMB                      ((PWM_T*)(APB2_BASE + 0x40000)) 

//------------------------- SPI Interface Controller --------------------------
typedef struct{
    __IO uint32_t CNTRL ;
    __IO uint32_t DIVIDER ;
    __IO uint32_t SSR ;
    __I  uint32_t RESERVE0 ;
    __I  uint32_t RX0 ;
    __I  uint32_t RX1 ;
    __I  uint32_t RESERVE1 ;
    __I  uint32_t RESERVE2 ;
    __O  uint32_t TX0 ;
    __O  uint32_t TX1 ;
    __I  uint32_t RESERVE3 ;
    __I  uint32_t RESERVE4 ;
    __I  uint32_t RESERVE5 ;
    __IO uint32_t VARCLK ;
    __I  uint32_t RESERVE6 ;
    __IO uint32_t CNTRL2 ;
    __IO uint32_t FIFO_CTL ;
    __IO uint32_t STATUS ;
}SPI_T ;

#define  SPI0                      ((SPI_T*)(APB1_BASE + 0x30000))  
#define  SPI1                      ((SPI_T*)(APB1_BASE + 0x34000))  

//----------------------------- TIMER Controller ------------------------------
typedef struct
{
    __IO uint32_t  TCSR ;                
    __IO uint32_t  TCMPR ;		        
    __IO uint32_t  TISR ;		        
    __IO uint32_t  TDR ;			        
    __IO uint32_t  TCAP ;		        
    __IO uint32_t  TEXCON ;	            
    __IO uint32_t  TEXISR ;	            
}TIMER_T ;

#define  TIMER0                    ((TIMER_T*)(APB1_BASE + 0x10000)) 
#define  TIMER1                    ((TIMER_T*)(APB1_BASE + 0x10020))
#define  TIMER2                    ((TIMER_T*)(APB2_BASE + 0x10000)) 
#define  TIMER3                    ((TIMER_T*)(APB2_BASE + 0x10020)) 

//------------------------- UART Interface Controller -------------------------
typedef struct{                                
    union {                             
      __IO uint32_t THR ;                  
      __IO uint32_t RBR ;                  
    } ;
    __IO uint32_t IER ;                  
    __IO uint32_t FCR ;                  
    __IO uint32_t LCR ;                  
    __IO uint32_t MCR ;                  
    __IO uint32_t MSR ;                  
    __IO uint32_t FSR ;                  
    __IO uint32_t ISR ;                  
    __IO uint32_t TOR ;                  
    __IO uint32_t BAUD ;                 
    __IO uint32_t IRCR ;                 
    __IO uint32_t ALT_CSR ;               
    __IO uint32_t FUNSEL ;               
}UART_T ;

#define  UART0                     ((UART_T*)(APB1_BASE + 0x50000)) 
#define  UART1                     ((UART_T*)(APB2_BASE + 0x50000)) 

//----------------------------- WDT Controller --------------------------------
typedef struct{
    __IO uint32_t  WTCR;                 
    __IO uint32_t  WTCRALT;              
}WDT_T ;

#define  WDT                       ((WDT_T*)(APB1_BASE + 0x4000))

//----------------------------- WWDT Controller -------------------------------
typedef struct{
    __IO uint32_t  RELOAD ;
    __IO uint32_t  CR ;
    __IO uint32_t  SR ;
    __IO uint32_t  VALUE ;
}WWDT_T ;

#define  WWDT                      ((WWDT_T*)(APB1_BASE + 0x4100))


//=======================================================================================
// ----------- BIT CONSTANT DEFINE USED FOR REGISTER---------------------------------
//=======================================================================================
//------------------- BIT CONSTANT for Analog Comparator---------------------------------
//// ACMPA->CR0, ACMPA->CR1, ACMPB->CR0, ACMPB->CR1, ////////////////////////////////////
#define  ACMP_OUT_INV              0x00000040
#define  ACMP_CN_BANGGAP           0x00000010              // ˽ڲѹ1.25V
#define  ACMP_HYST_EN              0x00000004              // زʹ
#define  ACMP_IE                   0x00000002       
#define  ACMP_EN                   0x00000001

//// ACMPA->SR,  ACMPB->SR //////////////////////////////////////////////////////////////
#define  ACMP_OUT1                 0x00000008              //OUTλ
#define  ACMP_OUT0                 0x00000004    
#define  ACMP_CF1                  0x40000002              //жϱ־
#define  ACMP_CF0                  0x60000001

//------------------- BIT CONSTANT for ADC ----------------------------------------------
//// ADC->CR ////////////////////////////////////////////////////////////////////////////
#define  AD_START_BUSY             0x00000800              //ADCʼ
#define  AD_DIFFEN                 0x00000400
#define  AD_TRG_EN                 0x00000100              //PINADCʹ
#define  AD_RISE_TRG               0x000000C0              //PINش
#define  AD_FALL_TRG               0x00000080              //PINش
#define  AD_HIGH_LEVEL_TRG         0x00000040              //PINߵƽ
#define  AD_LOW_LEVEL_TRG_0        0                       //PIN͵ƽ
#define  AD_PWM_TRG                0x00000030
#define  AD_STADC_TRG_0            0
#define  AD_CONTINUOUS_MODE        0x0000000C
#define  AD_SINGLE_SCAN            0x00000008
#define  AD_BURST_MODE             0x00000004
#define  AD_SINGLE_MODE_0          0
#define  AD_IE                     0x00000002              
#define  AD_EN                     0x00000001

//// ADC->DR ////////////////////////////////////////////////////////////////////////////
#define  AD_VALID                  0x00020000              // ݿ
#define  AD_OVRUN                  0x00010000              // ݸ

//// ADC->CMPR0, ADC->CMPR1 /////////////////////////////////////////////////////////////
#define  AD_CMP_CNT_MASK           0x00000F00              // Ƚϼ
#define  AD_CMP_CH_3bit(x)         ((x##ul) << 3)
#define  AD_CMP_GREAT              0x00000004              // ȽϽڵ, С
#define  AD_CMPIE                  0x00000002              // Ƚжʹ
#define  AD_CMPEN                  0x00000001              // Ƚʹ

//// ADC->SR ////////////////////////////////////////////////////////////////////////////
#define  ADSR_OVERRUN              0x00010000              //ݸw
#define  ADSR_VALID                0x00000100              //ݿ
#define  ADSR_CHANNEL_MASK         0x00000070
#define  ADSR_BUSY                 0x00000008              //ת
#define  ADSR_CMPF1                0x00000004              //Ƚ1жϱ־
#define  ADSR_CMPF0                0x00000002
#define  ADSR_ADF                  0x00000001              //ADCжϱ־

//------------------- BIT CONSTANT for Clock --------------------------------------------
////CLK->PWRCON , Դλ ////////////////////////////////////////////////////////////
#define  PWR_DOWN_WAIT_WFI_        0x00000100    //λΪ0,λ7д1ͽ״̬
#define  PWR_DOWN_EN_              0x00000080    //״̬,_WFI()ָ
#define  PWR_WAKEUP_F              0x00000040    //ѱ־,д10
#define  PWR_WAKEUP_INT_EN_        0x00000020    //Ѻжʹ
#define  PWR_WAKEUP_DELAY_         0x00000010    //Ѻʱ4096()16()ʱ
#define  PWR_10K_ON_               0x00000008    //Ƭ10Kϵ繤
#define  PWR_22M_ON_               0x00000004    //Ƭ22.1184MHz
#define  PWR_EXT_HI_               0x00000001    //4M~24M

////CLK->AHPCLK /////////////////////////////////////////////////////////////////////////
#define  CLK_HDIV_EN               0x00000010    //ʱʹ
#define  CLK_EBI_EN                0x00000008    //EBIʱʹ
#define  CLK_ISP_EN                0x00000004    //ISPʱʹ

////CLK->APBCLK , ʱʹλ/////////////////////////////////////////////////////////
#define  CLK_ACMP23_EN             0x80000000    //ʱʹ , а
#define  CLK_ACMP01_EN             0x40000000
#define  CLK_ADC_EN                0x10000000
#define  CLK_PWM67_EN              0x00800000
#define  CLK_PWM45_EN              0x00400000
#define  CLK_PWM23_EN              0x00200000
#define  CLK_PWM01_EN              0x00100000
#define  CLK_UART1_EN              0x00020000
#define  CLK_UART0_EN              0x00010000
#define  CLK_SPI1_EN               0x00002000
#define  CLK_SPI0_EN               0x00001000
#define  CLK_I2C1_EN               0x00000200         
#define  CLK_I2C0_EN               0x00000100         
#define  CLK_FDIV_EN               0x00000040
#define  CLK_TMR3_EN               0x00000020    
#define  CLK_TMR2_EN               0x00000010
#define  CLK_TMR1_EN               0x00000008   
#define  CLK_TMR0_EN               0x00000004
#define  CLK_WDT_EN                0x00000001    


////CLK->CLKSTATUS , ʱ״̬λ /////////////////////////////////////////////////////////
#define  CLKSTA_SWITCH_FAIL        0x00000080    //ʱлʧ
#define  CLKSTA_22M_STABLE         0x00000010    //22Mʱȶ
#define  CLKSTA_10K_STABLE         0x00000008    //10Kʱȶ
#define  CLKSTA_PLL_STABLE         0x00000004    //PLLʱȶ
#define  CLKSTA_EXT_STABLE         0x00000001    //ⲿʱȶ

////CLK->CLKSEL0 , ʱѡλ ///////////////////////////////////////////////////////////
#define  CLKS0_TICK_22M_DIV2_      0x00000038    //SysTickѡ22MĶƵ
#define  CLKS0_TICK_HCLK_DIV2_     0x00000018    //SysTickѡHCLKĶƵ
#define  CLKS0_TICK_EXT_DIV2_      0x00000010    //SysTickѡʱӵĶƵ
#define  CLKS0_TICK_EXT_0_         0             //SysTickѡʱ

#define  CLKS0_HCLK_22M_           0x00000007    //HCLKѡ22.1184Mʱ
#define  CLKS0_HCLK_10K_           0x00000003    //HCLKѡ10Kʱ
#define  CLKS0_HCLK_PLL_           0x00000002    //HCLKѡPLLʱ
#define  CLKS0_HCLK_EXT_0_         0             //HCLKѡʱ

////CLK->CLKSEL1 , ʱѡλ ///////////////////////////////////////////////////////////
#define  CLKS1_PWM23CLK_MASK       0xC0000000
#define  CLKS1_PWM23_22M           0xC0000000
#define  CLKS1_PWM23_HCLK          0x80000000
#define  CLKS1_PWM23_10K           0x40000000 
#define  CLKS1_PWM23_EXT_0         0 

#define  CLKS1_PWM01CLK_MASK       0x30000000
#define  CLKS1_PWM01_22M           0x30000000
#define  CLKS1_PWM01_HCLK          0x20000000
#define  CLKS1_PWM01_10K           0x10000000 
#define  CLKS1_PWM01_EXT_0         0 

#define  CLKS1_UART_PLL            0x01000000
#define  CLKS1_UART_EXT_0          0 

#define  CLKS1_TMR3CLK_MASK        0x00700000
#define  CLKS1_TMR3_22M            0x00700000    //Ƭ22M
#define  CLKS1_TMR3_10K            0x00500000    //Ƭ10K
#define  CLKS1_TMR3_CLK_PIN        0x00300000    //ʱʱ
#define  CLKS1_TMR3_HCLK           0x00200000    //HCLK
#define  CLKS1_TMR3_EXT_0          0             //Ӿ

#define  CLKS1_TMR2CLK_MASK        0x00070000
#define  CLKS1_TMR2_22M            0x00070000    //Ƭ22M
#define  CLKS1_TMR2_10K            0x00050000    //Ƭ10K
#define  CLKS1_TMR2_CLK_PIN        0x00030000    //ʱʱ
#define  CLKS1_TMR2_HCLK           0x00020000    //HCLK
#define  CLKS1_TMR2_EXT_0          0             //Ӿ

#define  CLKS1_TMR1CLK_MASK        0x00007000
#define  CLKS1_TMR1_22M            0x00007000    //Ƭ22M
#define  CLKS1_TMR1_10K            0x00005000    //Ƭ10K
#define  CLKS1_TMR1_CLK_PIN        0x00003000    //ʱʱ
#define  CLKS1_TMR1_HCLK           0x00002000    //HCLK
#define  CLKS1_TMR1_EXT_0          0             //Ӿ

#define  CLKS1_TMR0CLK_MASK        0x00000700
#define  CLKS1_TMR0_22M            0x00000700    //Ƭ22M
#define  CLKS1_TMR0_10K            0x00000500    //Ƭ10K
#define  CLKS1_TMR0_CLK_PIN        0x00000300    //ʱʱ
#define  CLKS1_TMR0_HCLK           0x00000200    //HCLK
#define  CLKS1_TMR0_EXT_0          0             //Ӿ

#define  CLKS1_SPI1_HCLK           0x00000020
#define  CLKS1_SPI1_PLL_0          0
#define  CLKS1_SPI0_HCLK           0x00000010
#define  CLKS1_SPI0_PLL_0          0

#define  CLKS1_ADCCLK_MASK         0x0000000C
#define  CLKS1_ADC_22M             0x0000000C
#define  CLKS1_ADC_HCLK            0x00000008
#define  CLKS1_ADC_PLL             0x00000004
#define  CLKS1_ADC_EXT_0           0 

#define  CLKS1_WDTCLK_MASK_        0x00000003
#define  CLKS1_WDT_10K_            0x00000003
#define  CLKS1_WDT_HCLK2048_       0x00000002  

////CLK->CLKSEL2 , ʱѡλ ///////////////////////////////////////////////////////////
#define  CLKS2_WWDT_10K            0x00030000
#define  CLKS2_WWDT_HCLK2048       0x00020000 

#define  CLKS2_PWM67CLK_MASK       0x000000C0
#define  CLKS2_PWM67_22M           0x000000C0
#define  CLKS2_PWM67_HCLK          0x00000080
#define  CLKS2_PWM67_10K           0x00000040
#define  CLKS2_PWM67_EXT_0         0 

#define  CLKS2_PWM45CLK_MASK       0x00000030
#define  CLKS2_PWM45_22M           0x00000030
#define  CLKS2_PWM45_HCLK          0x00000020
#define  CLKS2_PWM45_10K           0x00000010
#define  CLKS2_PWM45_EXT_0         0 

#define  CLKS2_FDIV_MASK           0x00000003
#define  CLKS2_FDIV_22M            0x00000003
#define  CLKS2_FDIV_HCLK           0x00000002
#define  CLKS2_FDIV_10K            0x00000001 
#define  CLKS2_FDIV_EXT_0          0 

////CLK->CLKDIV /////////////////////////////////////////////////////////////////////////
#define  ADC_CLK_DIV_8bit(x)       (((x##ul)-1)<<16)       //xֵ 1~256
#define  UART_CLK_DIV_4bit(x)      (((x##ul)-1)<<8)        //xֵ 1~16
#define  HCLK_DIV_4bit(x)          ((x##ul)-1)             //xֵ 1~16

////CLK->PLL /////////////////////////////////////////////////////////////////////////
#define  PLL_CLK_SRC_22M           0x00080000ul         
#define  PLL_CLK_SRC_EXT_0         0
#define  PLL_OFF_WHEN_PD           0x00010000ul            // ״̬PLL  
#define  PLL_OUT_DIV4              0xC000ul                // Ƶ
#define  PLL_OUT_DIV2              0x4000ul                
#define  PLL_OUT_DIV1_0            0                       //ʱӱ4M~24M֮
#define  PLL_IN_DIV(x)             (((x##ul)-2)<<9)        //Ƶ1.6M~15MHz֮
#define  PLL_MUL(x)                (x-2)                   //Ƶ100M~200MHZ֮             

////CLK->FRQDIV /////////////////////////////////////////////////////////////////////////
#define  FQRDIV_1                  0x00000020              //Ƶֱ,Ϊ0Ƶ
#define  FQRDIV_EN                 0x00000010              //ʱӷƵʹ
#define  FQRDIV_DIV_POWER(x)       ((x##ul)-1)             //Ƶϵ:2ָ,1~16
  
//------------------- BIT CONSTANT for FLASH Memory--------------------------------------
////FMC->CON //////ܱĴ//////////////////////////////////////////////////////////
#define  FMC_FAIL_                 0x00000040              //ʧ
#define  FMC_LDROM_WR_EN_          0x00000020              //APROMдLDROM
#define  FMC_CFG_WR_EN_            0x00000010              //APROMдconfig
#define  FMC_APUEN_                0x00000008              //APROMдAPROM
#define  FMC_BOOT_LDROM_           0x00000002              //LDROM
#define  FMC_EN_                   0x00000001

////FMC->CMD /////////////////////////////////////////////////////////////////////////
#define  FMC_VECT_REMAP            0x0000002E
#define  FMC_ERASE                 0x00000022
#define  FMC_WRITE                 0x00000021
#define  FMC_RD_CID                0x0000000B
#define  FMC_RD_UID                0x00000004
#define  FMC_READ_0                0

////FMC->TRG /////////////////////////////////////////////////////////////////////////
#define  FMC_GO_BUSY_              0x00000001	             //˼Ĵһλ,ܱλ

//------------------- BIT CONSTANT for Global Controller --------------------------------
////GCR->RSTSRC /////////////////////////////////////////////////////////////////////////
#define  RST_SRC_CPU               0x00000080 
#define  RST_SRC_MCU               0x00000020
#define  RST_SRC_BOD               0x00000010
#define  RST_SRC_LVR               0x00000008
#define  RST_SRC_WTD               0x00000004
#define  RST_SRC_PIN               0x00000002
#define  RST_SRC_POR               0x00000001 

////GCR->IPRSTC1 ////////////////////////////////////////////////////////////////////////
#define  RST_HDIV                  0x00000010            
#define  RST_EBI                   0x00000008
#define  RST_CPU                   0x00000002 
#define  RST_CHIP                  0x00000001

////GCR->IPRSTC2 ////////////////////////////////////////////////////////////////////////
#define  RST_ADC                   (1<<28) 
#define  RST_ACMP23                (1<<23)
#define  RST_ACMP01                (1<<22)
#define  RST_PWMB                  (1<<21) 
#define  RST_PWMA                  (1<<20) 
#define  RST_UART1                 (1<<17)
#define  RST_UART0                 (1<<16)
#define  RST_SPI1                  (1<<13) 
#define  RST_SPI0                  (1<<12) 
#define  RST_IIC1                  (1<<9)
#define  RST_IIC0                  (1<<8)
#define  RST_T3                    0x00000020
#define  RST_T2                    0x00000010 
#define  RST_T1                    0x00000008
#define  RST_T0                    0x00000004 
#define  RST_GPIO                  0x00000002

////GCR->BODCTL //////////////////////////////////////////////////////////////////////
#define  BOD_LVR_EN_               0x00000080 
#define  BOD_OUT_LOW_VOL           0x00000040 
#define  BOD_LPM_                  0x00000020
#define  BOD_IF                    0x00000010
#define  BOD_RST_EN_               0x00000008 
#define  BOD_V44_                  0x00000006
#define  BOD_V37_                  0x00000004
#define  BOD_V27_                  0x00000002
#define  BOD_V22_0_                0
#define  BOD_EN_                   0x00000001

////GCR->TEMPCR /////////////////////////////////////////////////////////////////////
#define  TEMP_EN                   0x00000001              // ʹ¶ȴ

////GCR->REGWRPROT //////////////////////////////////////////////////////////////////
#define  REG_UNLOCK                0x00000001              // ѽ
 
//// GCR->P0_MFP ///////////////////////////////////////////////////////////////////
#define  P07_MASK                  0x8080       
#define  P07_SPICLK1               0x8000
#define  P07_EBI_AD7               0x0080

#define  P06_MASK                  0x4040       
#define  P06_MISO1                 0x4000
#define  P06_EBI_AD6               0x0040

#define  P05_MASK                  0x2020       
#define  P05_MOSI1                 0x2000
#define  P05_EBI_AD5               0x0020

#define  P04_MASK                  0x1010       
#define  P04_SPISS1                0x1000
#define  P04_EBI_AD4               0x0010

#define  P03_MASK                  0x0808       
#define  P03_RXD                   0x0808       
#define  P03_RTS0                  0x0800
#define  P03_EBI_AD3               0x0008

#define  P02_MASK                  0x0404       
#define  P02_TXD                   0x0400
#define  P02_CTS0                  0x0400
#define  P02_EBI_AD2               0x0004

#define  P01_MASK                  0x0202       
#define  P01_RXD1                  0x0202       
#define  P01_RTS1                  0x0200
#define  P01_EBI_AD1               0x0002

#define  P00_MASK                  0x0101       
#define  P00_TXD1                  0x0101       
#define  P00_CTS1                  0x0100
#define  P00_EBI_AD0               0x0001

#define  P01_ACMP3_N               0x02000000            
#define  P00_ACMP3_P               0x01000000

//// GCR->P1_MFP ///////////////////////////////////////////////////////////////////
#define  P17_MASK                  0x8080       
#define  P17_ACMP2_P               0x8080
#define  P17_SPICLK0               0x8000
#define  P17_AIN7                  0x0080

#define  P16_MASK                  0x4040  
#define  P16_ACMP2_N               0x4040
#define  P16_MISO0                 0x4000
#define  P16_AIN6                  0x0040

#define  P15_MASK                  0x2020       
#define  P15_ACMP0_P               0x2020
#define  P15_MOSI0                 0x2000
#define  P15_AIN5                  0x0020

#define  P14_MASK                  0x1010       
#define  P14_ACMP0_N               0x1010
#define  P14_SPISS0                0x1000
#define  P14_AIN4                  0x0010

#define  P13_MASK                  0x0808       
#define  P13_TXD1                  0x0800
#define  P13_AIN3                  0x0008

#define  P12_MASK                  0x4040  
#define  P12_RXD1                  0x4000
#define  P12_AIN2                  0x0040

#define  P11_MASK                  0x2020       
#define  P11_WRH                   0x2020
#define  P11_T3                    0x2000
#define  P11_AIN1                  0x0020

#define  P10_MASK                  0x1010       
#define  P10_WRL                   0x1010
#define  P10_T2                    0x1000
#define  P10_AIN0                  0x0010

//// GCR->P2_MFP ///////////////////////////////////////////////////////////////////
#define  P27_MASK                  0x8080
#define  P27_PWM7                  0x8000
#define  P27_EBI_AD15              0x0080

#define  P26_MASK                  0x4040
#define  P26_ACMP1_OUT             0x4040
#define  P26_PWM6                  0x4000
#define  P26_EBI_AD14              0x0040

#define  P25_MASK                  0x2020
#define  P25_IIC1_SDA              0x2020
#define  P25_PWM5                  0x2000
#define  P25_EBI_AD13              0x0020

#define  P24_MASK                  0x1010
#define  P24_IIC1_SCL              0x1010
#define  P24_PWM4                  0x1000
#define  P24_EBI_AD12              0x0010

#define  P23_MASK                  0x0808
#define  P23_PWM3                  0x0800
#define  P23_EBI_AD11              0x0008

#define  P22_MASK                  0x0404
#define  P22_PWM2                  0x0400
#define  P22_EBI_AD10              0x0004

#define  P21_MASK                  0x0202
#define  P21_PWM1                  0x0200
#define  P21_EBI_AD9               0x0002

#define  P20_MASK                  0x0101
#define  P20_PWM0                  0x0100
#define  P20_EBI_AD8               0x0001

//// GCR->P3_MFP ///////////////////////////////////////////////////////////////////
#define  P37_MASK                  0x8080
#define  P37_EBI_RD                0x0080

#define  P36_MASK                  0x4040
#define  P36_ACMP0_OUT             0x4040
#define  P36_CKO                   0x4000
#define  P36_EBI_WR                0x0040

#define  P35_MASK                  0x2020
#define  P35_CKO                   0x2020
#define  P35_IIC0_SCL              0x2000
#define  P35_T1                    0x0020

#define  P34_MASK                  0x1010
#define  P34_IIC0_SDA              0x1000
#define  P34_T0                    0x0010

#define  P33_MASK                  0x0808
#define  P33_T1EX                  0x0808
#define  P33_MCLK                  0x0800
#define  P33_INT1                  0x0008

#define  P32_MASK                  0x0404
#define  P32_T0EX                  0x0400
#define  P32_INT0                  0x0004

#define  P31_MASK                  0x0202
#define  P31_ACMP1_P               0x0200
#define  P31_TXD0                  0x0002

#define  P30_MASK                  0x0101
#define  P30_ACMP1_N               0x0100
#define  P30_RXD0                  0x0001

//// GCR->P4_MFP ///////////////////////////////////////////////////////////////////
#define  P47_MASK                  0x8080
#define  P47_ICE_DAT               0x0080

#define  P46_MASK                  0x4040
#define  P46_ICE_CLK               0x0040

#define  P45_MASK                  0x2020
#define  P45_IIC1_SDA              0x2000
#define  P45_EBI_ALE               0x0020

#define  P44_MASK                  0x1010
#define  P44_IIC1_SCL              0x1000
#define  P44_EBI_CS                0x0010

#define  P43_MASK                  0x0808
#define  P43_PWM3                  0x0008

#define  P42_MASK                  0x0404
#define  P42_PWM2                  0x0004

#define  P41_MASK                  0x0202
#define  P41_T3EX                  0x0200
#define  P41_PWM1                  0x0002

#define  P40_MASK                  0x0101
#define  P40_T2EX                  0x0100
#define  P40_PWM0                  0x0001

//------------------- BIT CONSTANT for GPIO ---------------------------------------------
////P0->PMD,P1->PMD,P2->PMD,P3->PMD,P4->PMD /////////////////////////////////////////
#define  Px0_IN_0                  0 
#define  Px0_OUT                   0x00000001
#define  Px0_OD                    0x00000002
#define  Px0_QB                    0x00000003
#define  Px0_PMD_MASK              0x00000003 

#define  Px1_IN_0                  0 
#define  Px1_OUT                   0x00000004
#define  Px1_OD                    0x00000008
#define  Px1_QB                    0x0000000C
#define  Px1_PMD_MASK              0x0000000C

#define  Px2_IN_0                  0 
#define  Px2_OUT                   0x00000010
#define  Px2_OD                    0x00000020
#define  Px2_QB                    0x00000030
#define  Px2_PMD_MASK              0x00000030

#define  Px3_IN_0                  0
#define  Px3_OUT                   0x00000040
#define  Px3_OD                    0x00000080
#define  Px3_QB                    0x000000C0
#define  Px3_PMD_MASK              0x000000C0

#define  Px4_IN_0                  0
#define  Px4_OUT                   0x00000100
#define  Px4_OD                    0x00000200
#define  Px4_QB                    0x00000300
#define  Px4_PMD_MASK              0x00000300

#define  Px5_IN_0                  0
#define  Px5_OUT                   0x00000400
#define  Px5_OD                    0x00000800
#define  Px5_QB                    0x00000C00
#define  Px5_PMD_MASK              0x00000C00

#define  Px6_IN_0                  0 
#define  Px6_OUT                   0x00001000
#define  Px6_OD                    0x00002000
#define  Px6_QB                    0x00003000
#define  Px6_PMD_MASK              0x00003000

#define  Px7_IN_0                  0 
#define  Px7_OUT                   0x00004000
#define  Px7_OD                    0x00008000
#define  Px7_QB                    0x0000C000
#define  Px7_PMD_MASK              0x0000C000
//------------------- BIT CONSTANT for I2C ----------------------------------------------
////I2C0->CON, I2C1->CON ////////////////////////////////////////////////////////////////
#define  I2C_IE                    0x00000080
#define  I2C_EN				             0x00000040
#define  I2C_STA				           0x00000020
#define  I2C_STO				           0x00000010
#define  I2C_SI					           0x00000008
#define  I2C_AA					           0x00000004
////I2C0->TOC, I2C1->TOC ////////////////////////////////////////////////////////////////
#define  I2C_TO_EN                 0x00000004
#define  I2C_TO_DIV4               0x00000002              //ʱķƵ
#define  I2C_TO_IF				         0x00000001

////I2C0->ADDR0, I2C0->ADDR1, I2C0->ADDR2, I2C0->ADDR3, ////////////////////////////////
////I2C1->ADDR0, I2C1->ADDR1, I2C1->ADDR2, I2C1->ADDR3, ////////////////////////////////
#define  I2C_ADRESS_7bit(x)        ((x##ul)<<1)
#define  I2C_GC                    0x00000001			         //㲥ʹ

//------------------- BIT CONSTANT for PWM ----------------------------------------------
//// PWMA->PPR, PWMB->PPR ///////////////////////////////////////////////////////////////
#define  PPR_DZ23(x)               ((x##ul-1)<<24)
#define  PPR_DZ01(x)               ((x##ul-1)<<16)
#define  PPR_PWM23_DIV(x)          ((x##ul-1)<<8)
#define  PPR_PWM01_DIV(x)          (x##ul-1)

//// PWMA->CSR, PWMB->CSR ///////////////////////////////////////////////////////////////
#define  CSR_DIV1_CH(CHANNEL)      (4ul<<(4*(CHANNEL)))
#define  CSR_DIV2_CH(CHANNEL)      (0ul<<(4*(CHANNEL)))
#define  CSR_DIV4_CH(CHANNEL)      (1ul<<(4*(CHANNEL)))
#define  CSR_DIV8_CH(CHANNEL)      (2ul<<(4*(CHANNEL)))
#define  CSR_DIV16_CH(CHANNEL)     (3ul<<(4*(CHANNEL)))

//// PWMA->PCR, PWMB->PCR ///////////////////////////////////////////////////////////////
#define  PCR_PWM23_CENTER_TYPE     0x80000000              // Ķģʽ, ض
#define  PCR_PWM01_CENTER_TYPE     0x40000000
#define  PCR_DZEN23_EN             0x00000020
#define  PCR_DZEN01_EN             0x00000010

#define  PCR_PERIOD_MOD_CH(CHANNEL) (8ul<<(8*(CHANNEL)))   // ģʽ
#define  PCR_PINV_CH(CHANNEL)      (2ul<<(8*(CHANNEL)))    // 
#define  PCR_EN_CH(CHANNEL)        (1ul<<(8*(CHANNEL)))    // ͨʹ

//// PWMA->PIER, PWMB->PIER /////////////////////////////////////////////////////////////
#define  PIER_PWM23_UP_DINT        0x02000000              // Dutyж, ½
#define  PIER_PWM01_UP_DINT        0x01000000
#define  PIER_PWM23_OV_PINT        0x00020000              //ֵʱж,Ϊ0ʱж
#define  PIER_PWM01_OV_PINT        0x00010000
#define  PIER_DIE_CH(CHANNEL)      (1<<((CHANNEL)+8))
#define  PIER_PIE_CH(CHANNEL)      (1<<(CHANNEL))

//// PWMA->PIIR, PWMB->PIIR /////////////////////////////////////////////////////////////
#define  PIIR_DIF_CH(CHANNEL)      (1<<((CHANNEL)+8))
#define  PIIR_PIF_CH(CHANNEL)      (1<<(CHANNEL))

//// PWMA->POE, PWMB->POE ///////////////////////////////////////////////////////////////
#define  POE_CH(CHANNEL)           (1<<(CHANNEL))

//// PWMA->TCON, PWMB->TCON /////////////////////////////////////////////////////////////
#define  PWMD_TRG_ADC_CH(CHANNEL)  (1<<((CHANNEL)+8))      // ػж
#define  PWMP_TRG_ADC_CH(CHANNEL)  (1<<(CHANNEL))          // ߵ㻹ǵ͵ж

//// PWMA->TSTATUS, PWMB->TSTATUS ///////////////////////////////////////////////////////
#define  PWM_TRG_ADC_CH(CHANNEL)   (1<<(CHANNEL))          // ADC  PWM ı־λ

//// PWMA->PSCR, PWMB->PSCR /////////////////////////////////////////////////////////////
#define  PWM_SYNH_CH(CHANNEL)     (1<<(8*(CHANNEL)))      // PWM ͬʹλ

//------------------- BIT CONSTANT for SPI ----------------------------------------------
//// SPI0->CNTRL, SPI1->CNTRL ///////////////////////////////////////////////////////////
#define  SPI_FIFO_EN               (1<<21)
#define  SPI_RE_ORDER              (1<<19)
#define  SPI_SLAVE_MODE            (1<<18)
#define  SPI_IE                    (1<<17)       //һδжʹ
#define  SPI_IF                    (1<<16)
#define  SPI_INTERVAL_4bit(x)      ((x##ul)<<12) // SPIݼ
#define  SPI_CLK_NEGTIVE           (1<<11)       //CLKΪ,ʱΪ(λΪ0CLK)
#define  SPI_LSB                   (1<<10)       //λǰ, λǰ
#define  SPI_BIT_LEN_5bit(x)       ((x##ul)<<3)  //Range from 8 to 32 
#define  SPI_CLK_FALL_TX           0x00000004
#define  SPI_CLK_FALL_RX           0x00000002
#define  SPI_TX_GO_BUSY            0x00000001

//// SPI0->SSR, SPI1->SSR ///////////////////////////////////////////////////////////////
#define  SPI_TRANSFER_FINISH       0x00000020    //ģʽ, յһδеʱ
#define  SPI_SS_LEVEL_TRG          0x00000010    //ģʽ, SSƽЧ, н
#define  SPI_SS_AUTO_EN            0x00000008    //ʹԶƬѡ,
#define  SPI_SS_HIGH               0x00000004    //Ƭѡ߻Ч,ͻЧ
#define  SPI_SS_ASSERT             0x00000001    //Ƭѡʹ, Only master,

//// SPI0->CNTRL2, SPI1->CNTRL2 /////////////////////////////////////////////////////////
#define  SPI_CLK_SAME_BN           (1<<31)       //ʱBN
#define  SPI_3L_SSI_IE             (1<<16)       //ƬѡЧʱж, IF λ
#define  SPI_3L_STA_IE             (1<<10)       //ģʽ俪ʼʱ, ж, Զ
#define  SPI_3L_ABORT              (1<<9)        //ģʽֹ, 3ߴӻģʽ
#define  SPI_3L_MODE_EN            (1<<8)        //ߴӻģʽ

//// SPI0->FIFO_CTL, SPI1->FIFO_CTL /////////////////////////////////////////////////////
#define  SPI_TX_THRESHOLD_2Bit(x)  ((x)<<28)     // FiFO
#define  SPI_RX_THRESHOLD_2Bit(x)  ((x)<<24)     // FiFO
#define  SPI_RX_TOV_IE             ((x)<<21)     // ճʱжʹ
#define  SPI_RX_OV_IE              ((x)<<6)      // (4ֽ)жʹ
#define  SPI_TX_FIFO_IE            (8)           // FIFOֵжʹ
#define  SPI_RX_FIFO_IE            (4)           // FIFOֵжʹ
#define  SPI_CLR_TX_FIFO           (2)           // 㷢 FiFo
#define  SPI_CLR_RX_FIFO           (1)           //  FiFo

//// SPI0->STATUS, SPI1->STATUS /////////////////////////////////////////////////////////
#define  SPI_TX_FIFO_CNT_MASK      ((0xF)<<24)   // TX_FIFO, ݸ
#define  SPI_TX_FULL               (1<<27)
#define  SPI_TX_EMPTY              (1<<26)
#define  SPI_RX_FULL               (1<<25)
#define  SPI_RX_EMPTY              (1<<24)
#define  SPI_TOV                   (1<<20)       // ճʱ
#define  SPI_IF                    (1<<16)     

#define  SPI_RX_FIFO_CNT_MASK      ((0xF)<<12)   // RX FIFOݸ
#define  SPI_3L_STA_IF             (1<<11)       // 3ߴģʽʼ, жϱ־
#define  SPI_TX_FIFO_IF            (1<<4)        // FiFo, жϱ־
#define  SPI_RX_OV_IF              (4)           // FiFo, жϱ־
#define  SPI_RX_FIFO_IF            (1)           // FiFo, жϱ־

//------------------- BIT CONSTANT for TIMER --------------------------------------------
//// TIMER0->CSR, TIMER1->CSR, TIMER2->CSR, TIMER3->CSR /////////////////////////////////
#define  T_DEBUG_WORK              0x80000000
#define  T_CEN                     0x40000000
#define  T_IE                      0x20000000

#define  T_MODE_MASK               0x18000000
#define  T_MODE_CONTINUOUS		     0x18000000
#define  T_MODE_TOGGLE             0x10000000
#define  T_MODE_PERIODIC           0x08000000
#define  T_MODE_ONCE_0             0

#define  T_CRST                    0x04000000
#define  T_CNT_MODE                0x01000000
#define  T_WAKE_EN                 0x00800000
#define  T_CAP_ACMP                0x00400000    // Capture ACMPx, capture TxEX
#define  T_TOGGLE_TEX              0x00200000    // Toggle TxEX, Toggle Tx
#define  T_PERIODIC_ENH            0x00100000    // ģʽܸı
#define  T_INTR_TRG                0x00080000    // ڲģʽ
#define  T_TDR_EN                  0x00010000
                                                 //λ[15:8]û,λ[7:1]ΪԤƵϵ
//// TIMER0->ISR, TIMER1->ISR, TIMER2->ISR, TIMER3->ISR  ////////////////////////////////
#define  T_WAKUP_IF                0x000000002
#define  T_IF                      0x000000001   //ʹжϴ˱־Ż1

//// TIMER0->EXCON, TIMER1->EXCON, TIMER2->EXCON, TIMER3->EXCON /////////////////////////
#define  T_CNT_DEBO_EN             0x00000080    //  Tx ʹ
#define  TEX_DEBO_EN               0x00000040    //  TEX ʹ
#define  TEX_IE                    0x00000020
#define  TEX_CAP_RST_MODE          0x00000010    // Ÿλʱ

#define  TEX_EN                    0x00000008
#define  TEX_CAP_FALL_RISE         0x00000004  
#define  TEX_CAP_RISE              0x00000002 
#define  TEX_CAP_FALL_0            0x00000000

#define  T_CNT_RISE                0x00000001    // ؼ

//// TIMER0->EXISR, TIMER1->EXISR ///////////////////////////////////////////////////////
#define  TEX_IF                    0x00000001

//------------------- BIT CONSTANT for UART ---------------------------------------------
//// UART0->IER,  UART1->IER ////////////////////////////////////////////////////////////
#define  AUTO_CTS_EN               (1<<13)
#define  AUTO_RTS_EN               (1<<12)
#define  TOV_EN                    (1<<11)                 // ʱʹ
#define  CTS_WAKEUP_EN             0x00000040
#define  BUF_ERR_IE                0x00000020
#define  RX_TOV_IE                 0x00000010
#define  MODEM_IE                  0x00000008
#define  RX_LINE_IE                0x00000004
#define  TX_EMPTY_IE               0x00000002
#define  RX_DATA_IE                0x00000001

//// UART0->FCR,  UART1->FCR ////////////////////////////////////////////////////////////
#define  RTS_14BYTE_TRG            0x00030000
#define  RTS_8BYTE_TRG             0x00020000
#define  RTS_4BYTE_TRG             0x00010000
#define  RTS_1BYTE_TRG_0           0
#define  RX_DIS                    0x00000100    // ͨģʽյַǰ
#define  RX_FIFO_14BYTE_INT        0x00000030
#define  RX_FIFO_8BYTE_INT         0x00000020
#define  RX_FIFO_4BYTE_INT         0x00000010
#define  RX_FIFO_1BYTE_INT_0       0
#define  TX_RESET                  0x00000004
#define  RX_RESET                  0x00000002

//// UART0->LCR, UART1->LCR /////////////////////////////////////////////////////////////
#define  BREAK_ONE_FRAME           0x00000040
#define  PARITY_STICK_EN           0x00000020
#define  PARITY_EVEN_EN            0x00000010
#define  PARITY_EN                 0x00000008
#define  STOP_2BIT                 0x00000004              // 2STOP,  1STOP
#define  WORD_LEN_8BIT             0x00000003
#define  WORD_LEN_7BIT             0x00000002
#define  WORD_LEN_6BIT             0x00000001
#define  WORD_LEN_5BIT_0           0

//// UART0->MCR,  UART1->MCR ////////////////////////////////////////////////////////////
#define  RTS_PIN                   0x00002000              // RTS ֵ
#define  RTS_LOW_ACTIVE            0x00000200              // RTS Ч
#define  RTS_OUT_NOACTIVE          0x00000002              // ֱRTSЧ

//// UART0->MSR, UART1->MSR /////////////////////////////////////////////////////////////
#define  CTS_LOW_TRG               0x00000100
#define  CTS_PIN                   0x00800010
#define  CTS_CHANGE                0x00000001

//// UART0->FSR, UART1->FSR /////////////////////////////////////////////////////////////
#define  TX_EMPTY                  0x10000000
#define  TX_FIFO_OVER              0x01000000
#define  TX_FIFO_FULL              0x00800000
#define  TX_FIFO_EMPTY             0x00400000
#define  TX_FIFO_NUM_MASK          0x003F0000
#define  RX_FIFO_FULL              0x00008000
#define  RX_FIFO_EMPTY             0x00004000
#define  RX_FIFO_NUM_MASK          0x00003F00
#define  RX_BREAK_IF               0x00000040
#define  RX_FRAME_ERR              0x00000020
#define  RX_PARITY_ERR             0x00000010
#define  RX_ADRESS_MATCH           0x00000008
#define  RX_FIFO_OVER              0x00000001

//// UART0->ISR, UART1->ISR /////////////////////////////////////////////////////////////
#define  BUF_ERR_IF                0x00000020
#define  TOV_IF                    0x00000010
#define  MODEM_IF                  0x00000008
#define  RX_LINE_IF                0x00000004
#define  TX_EMPTY_IF               0x00000002
#define  RX_DATA_IF                0x00000001

//// UART0->BAUD, UART0->BAUD ///////////////////////////////////////////////////////////
#define  DIV_X_EN                  0x20000000              // XԤƵʹ,  16Ƶ
#define  DIV_X_ONE                 0x10000000              //  X = 1
#define  DIV_X(x)                  ((x##ul)<<24)
                                                           //  16 λΪʷƵ
//// UART0->IRCR, UART0->IRCR ///////////////////////////////////////////////////////////
#define  IRCR_RX_INV               0x00000040
#define  IRCR_TX_INV               0x00000020
#define  IRCR_TX_EN                0x00000002              // IRʹ, Ϊ

//// UART0->ALT_CSR, UART1->ALT_CSR /////////////////////////////////////////////////////
#define  M485_ADDR_8bit(x)         ((x##ul)<<24)
#define  M485_ADDR_EN              0x00008000              // ַʹ
#define  M485_AUTO_DIR             0x00000400              // Զ
#define  M485_DETEC_ADDR           0x00000200              // Զַ
#define  M485_NORMAL_MODE          0x00000100              // ͨģʽ

//// UART0->FUN_SEL, UART1->FUN_SEL /////////////////////////////////////////////////////
#define  SIO_MODE_MASK             3
#define  SIO_MODE_485              3
#define  SIO_MODE_IR               2
#define  SIO_MODE_LIN              1
#define  SIO_MODE_UART_0           0

//------------------- BIT CONSTANT for WDT ----------------------------------------------
//// WDT->WTCR //////////////////////////////////////////////////////////////////////////
#define  WTD_DIS_WHEN_DEBUG_       (1<<31)
#define  WTD_TIM_3bit_(x)          ((x##ul)<<8) 
#define  WTD_EN_                   0x80
#define  WTD_IE_                   0x40
#define  WTD_WKUP_F_               0x20
#define  WTD_WKUP_EN_              0x10
#define  WTD_IF_                   0x08
#define  WTD_RST_F_                0x04
#define  WTD_RST_EN_               0x02
#define  WTD_CLEAR_                0x01

//// WDT->WTCRALT ///////////////////////////////////////////////////////////////////////
#define  WTD_RST_DELAY_3           3
#define  WTD_RST_DELAY_18          2
#define  WTD_RST_DELAY_130         1
#define  WTD_RST_DELAY_1026        0

//// WWDT->CR ///////////////////////////////////////////////////////////////////////////
#define  WTD_DIS_WHEN_DEBUG_       (1<<31)       // Debug ʱ WDT
#define  WWTD_CMP_IE               2             // Ƚƥжʹ
#define  WWTD_EN                   1

//// WWDT->SR ///////////////////////////////////////////////////////////////////////////
#define  WWTD_RIF                  2             // WDT λ־
#define  WWTD_CMP_IF               1             // Ƚƥжϱ־

//=============================================================================
typedef volatile unsigned char  vu8;
typedef volatile unsigned long  vu32;
typedef volatile unsigned short vu16;

#ifndef NULL
  #define NULL                     (0)
#endif

#define  TRUE                      (1)
#define  FALSE                     (0)

#define  _OK_                      (0)
#define  _ERR_                     (~0)

#define  ENABLE                    (1)
#define  DISABLE                   (0)

#endif
